#ifndef INCLEDED_COORDINATE_H
#define INCLEDED_COORDINATE_H
#include "state.h"
#include "enc_1multi.h"
extern Enc1Multi ec;
extern const double kArmOrigin[3];//アームの根本の座標
extern const double kArmLength[4];
extern const double kRadToDegree;//rad → degree の係数
extern const double kDegreeToRad;
extern double nowz;
void EcSetup();
//アーム先端の座標
double GetNowTipLocateX();
double GetNowTipLocateY();
double GetNowTipLocateZ();
//L3の根本の位置の座標
double GetNowElbowX();
double GetNowElbowY();
double GetNowElbowZ();
//現在のサーボ角度（絶対座標系での角度)
double GetNowRad(int num);
//現在のサーボ角度（相対角）
void SetNowRadRelative(int num, double rad);
double GetNowRadRelative(int num);
//次に動かすサーボ角度（相対角）
void SetNextRadRelative(int num, double rad);
double GetNextRadRelative(int num);
//次のアームの向きになるようサーボ角度を設定
void SetServoYawRad(double yaw_rad);//serov0,1の値を使って計算するので、決まってから呼び出す
void SetServoPitchRad(double pitch_rad);
//逆運動学で目標位置に行くサーボ角度を設定
void Set2LinkRad(double x_relative, double y_relative);
//手首から手先までの距離
double GetFromElbowToHand(unsigned int axis, double yaw_rad, double pitch_rad);
#endif